<?php
/**
* InstGroupMessagesPlugin.class.php
*
* 
*
*
* @author		Andr Noack <noack@data-quest.de>, Suchi & Berg GmbH <info@data-quest.de>
* @version		$Id:$
*/
// +---------------------------------------------------------------------------+
// This file is part of Stud.IP
// InstGroupMessagesPlugin.class.php
// ermglicht die Auswahl von Nutzergruppen an Einrichtungen
// Copyright (C) 2007 Andr Noack <noack@data-quest.de>
// Suchi & Berg GmbH <info@data-quest.de> 
// +---------------------------------------------------------------------------+
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or any later version.
// +---------------------------------------------------------------------------+
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
// +---------------------------------------------------------------------------+
require_once "lib/classes/StudipForm.class.php";

class InstGroupMessagesPlugin extends AbstractStudIPAdministrationPlugin {
	

	function InstGroupMessagesPlugin() {
		
		parent::AbstractStudIPAdministrationPlugin();
		
		$this->setPluginiconname("img/plugin.png");
		
		$navigation = new PluginNavigation();
		$navigation->setDisplayname($this->getDisplayname());
		$this->setNavigation($navigation);
		$top_navigation = new PluginNavigation();
		$top_navigation->setDisplayname($this->getDisplayname());
		$this->setTopnavigation($top_navigation);
	}
	
	function getDisplayname() {
		return _("Nachrichten an Nutzerguppen");
	}
	
	
	function actionShow() {
		$institute = $this->getInstitute();
		foreach($institute as $institut_id => $details){
			$options[] = array('value' => $institut_id, 'name' => (!$details['is_fak'] ? chr(160).chr(160) : '') . $details['name'] . ' ('.$details['num_user'] . ')');
		}
		$form_fields['institute'] = array('type' => 'selectbox', 'multiple' => true, 'options' => $options);
		$form_fields['status'] = array('type' => 'select', 'multiple' => true,'default_value' => 'dozent', 'options' => array(array('name' => 'autor', 'value' =>'autor'),array('name' => 'tutor', 'value' =>'tutor'),array('name' => 'dozent', 'value' =>'dozent'),array('name' => 'admin', 'value' =>'admin')));
		$form_buttons['reset'] = array('type' => 'zuruecksetzen', 'info' => _("Zurcksetzen"));
		$form_buttons['show'] = array('type' => 'anzeigen', 'info' => _("Ausgewhlte Nutzer anzeigen"));
		$form_buttons['send'] = array('type' => 'uebernehmen', 'info' => _("Nachricht an Nutzer verschicken"));
		$form = new StudipForm($form_fields, $form_buttons,"studipform", true);
		if($form->isClicked('reset')){
			$form->doFormReset();
			$form->persistent_values = null;
		}
		echo '<div style="margin:10px;">';
		echo _("Whlen sie die Einrichtung und den Status der Nutzer aus, denen sie eine Nachricht schicken wollen.");
		echo $form->getFormStart(PluginEngine::getLink($this));
		echo $form->getFormField('institute');
		echo '<div style="margin-left:5px;">';
		echo '<img '.makeButton('auswahlumkehr', 'src') . tooltip(_("Aktuelle Auswahl umkehren"));
		echo 'onclick="$(document.studipform).getInputs(\'checkbox\').each(function(i) {i.checked = i.checked ? false : true});"><br><br>';
		echo $form->getFormField('status');
		echo '&nbsp;&nbsp;&nbsp;';
		echo $form->getFormButton('show');
		echo $form->getFormButton('send');
		echo $form->getFormButton('reset');
		echo '</div>';
		echo $form->getFormEnd();
		$chosen_inst = $form->getFormFieldValue('institute');
		$chosen_status =  $form->getFormFieldValue('status');
		$db = new DB_Seminar();
		if(($form->isClicked('show') || $form->IsClicked('send')) && is_array($chosen_inst) && is_array($chosen_status)){
			$db->queryf("SELECT DISTINCT auth_user_md5.*, {$GLOBALS['_fullname_sql']['full']} as fullname FROM user_inst INNER JOIN auth_user_md5 USING(user_id) INNER JOIN user_info USING(user_id) WHERE Institut_id IN('%s') AND inst_perms IN('%s') ORDER BY Nachname", join("','",$chosen_inst), join("','",$chosen_status));
			if($db->num_rows()){
				if($form->IsClicked('send')){
					$_SESSION['sms_data'] = "";
					$_SESSION['sms_data']['tmpsavesnd'] = 1;
					$_SESSION['sms_data']['tmpemailsnd'] = 1;
					while ($db->next_record()) {
						$_SESSION['sms_data']['p_rec'][] = $db->f("username");
					}
					page_close();
					ob_end_clean();
					header("Location: {$GLOBALS['ABSOLUTE_URI_STUDIP']}sms_send.php");
					die();
				} else {
					echo '<table cellpadding="2" cellspacing="2" border="0">';
					echo '<tr><th>Name</th><th>Nutzername</th><th>Status global</th><th>Email</th></tr>';
					while($db->next_record()){
						echo '<tr>';
						echo '<td class="steel1">' . htmlReady($db->f('fullname')) . '</td>';
						echo '<td class="steel1" align="center"><a href="about.php?username='.$db->f('username').'">' . htmlReady($db->f('username')) . '</a></td>';
						echo '<td class="steel1" align="center">' . htmlReady($db->f('perms')) . '</td>';
						echo '<td class="steel1">' . htmlReady($db->f('Email')) . '</td>';
						echo '</tr>';
					}
					echo '</table>';
				}
			}
			echo '</div>';
		}
	}
	
	function getInstitute(){
		global $perm, $user;
		$db = new DB_Seminar();
		$db2 = new DB_Seminar();

		if($perm->have_perm('root')){
			$db->query("SELECT a.Institut_id,a.Name, 1 AS is_fak, count(user_id) AS num_user FROM Institute a
			LEFT JOIN user_inst ON(user_inst.Institut_id=a.Institut_id AND inst_perms <> 'user'  ) WHERE a.Institut_id=fakultaets_id GROUP BY a.Institut_id ORDER BY is_fak,Name");
		} else {
			$db->query("SELECT a.Institut_id,b.Name, IF(b.Institut_id=b.fakultaets_id,1,0) AS is_fak,count(c.user_id) AS num_user FROM user_inst a LEFT JOIN Institute b USING (Institut_id)
			LEFT JOIN user_inst c ON(c.Institut_id=a.Institut_id AND c.inst_perms <> 'user'  )	WHERE a.user_id='$user->id' AND a.inst_perms='admin' GROUP BY a.Institut_id ORDER BY is_fak,Name");
		}
		while($db->next_record()){
			$_my_inst[$db->f("Institut_id")] = array("name" => $db->f("Name"), "is_fak" => $db->f("is_fak"), "num_user" => $db->f("num_user"));
			if ($db->f("is_fak")){
				$db2->query("SELECT a.Institut_id, a.Name,count(user_id) AS num_user FROM Institute a
				LEFT JOIN user_inst ON(user_inst.Institut_id=a.Institut_id AND inst_perms <> 'user'  ) WHERE fakultaets_id='" . $db->f("Institut_id") . "' AND a.Institut_id!='" .$db->f("Institut_id") . "'
				GROUP BY a.Institut_id ORDER BY a.Name");
				$num_inst = 0;
				while ($db2->next_record()){
					if(!$_my_inst[$db2->f("Institut_id")]){
						++$num_inst;
					}
					$_my_inst[$db2->f("Institut_id")] = array("name" => $db2->f("Name"), "is_fak" => 0 , "num_user" => $db2->f("num_user"));
				}
				$_my_inst[$db->f("Institut_id")]["num_inst"] = $num_inst;
			}
		}
		return $_my_inst;
	}
}
?>
